

# (x_i , y_i)のデータ系列から未知の x_kに対応するy_kを求める
def predict_linear(data,target_x):

	x_vec =[]
	y_vec =[]

	for vec in data:
		x_vec.append(vec[0])
		y_vec.append(vec[1])
	
	#平均
	x_mu = sum(x_vec)/len(x_vec)
	y_mu = sum(y_vec)/len(y_vec)
	
	Sxy = 0
	Sxx = 0
	for i in range(0,len(x_vec)) :
		Sxy = (x_vec[i]-x_mu)*(y_vec[i]-y_mu) + Sxy
	
	for i in range(0,len(x_vec)) :
		Sxx = (x_vec[i]-x_mu)*(x_vec[i]-x_mu) + Sxx
	
	# a,b は1次回帰直線の傾きと係数
	a = Sxy / Sxx
	b = y_mu - a* x_mu

	return a * target_x + b



heikin_xy=[
	 [2,1.58],
	 [3, 2.54],
	 [4,3.44],
	 [5,4.159999999999999],
	 [6, 4.9],
	 [7, 5.8],
	 [8, 6.459999999999999],
]
target_x = 10
print("回帰:")
print(predict_linear(heikin_xy,target_x))

x= 10
yosou = (6.459999-1.5888)/(8-2)*(x-2)+1.58
print("2点:")
print(yosou)
